<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'MicrositeCtaTabs',
  props: {
    data: {
      required: true,
      default: null,
      type: Object,
    },
    partner: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      selectedTab: 0,
    };
  },
  methods: {
    selectTab(index) {
      this.selectedTab = index;
    },
  },
});
</script>

<template>
  <article class="cta-tab__container">
    <SlpTypography class="cta-tab__container--heading" tag="p" variant="body1">
      {{ data.heading }}
    </SlpTypography>
    <div class="cta-tab__tablist" role="tablist" aria-labelledby="tab-label">
      <button
        v-for="(tab, index) in data.tabs"
        :id="`${tab.tab.text.toLowerCase()}-tab`"
        :key="tab.text"
        role="tab"
        :class="['tab', index === selectedTab ? 'selected' : '']"
        :aria-selected="index === selectedTab ? 'true' : 'false'"
        :tabindex="index === selectedTab ? '-1' : '0'"
        :aria-controls="`${tab.tab.text.toLowerCase()}-tabpanel`"
        :data-ga-name="
          tab.tab.dataGaName.toLowerCase() || tab.tab.text.toLowerCase()
        "
        :data-ga-location="
          tab.tab.dataGaLocation.toLowerCase() || 'side navigation'
        "
        @click="selectTab(index)"
      >
        {{ tab.tab.text }}
      </button>
    </div>
    <div
      v-for="(tabContent, index) in data.tabs"
      v-show="index === selectedTab"
      :id="`${tabContent.tab.text}-tabpanel`"
      :key="tabContent.panel.text"
      class="cta-tab__tabpanel"
      :style="{ 'border-top-left-radius': selectedTab > 0 ? '8px' : '0' }"
      :aria-labelledby="`${tabContent.tab.text.toLowerCase()}-tab`"
    >
      <SlpTypography
        v-if="tabContent.panel.text"
        variant="body3"
        tag="div"
        class="slp-mb-24"
      >
        <div v-html="$md.render(tabContent.panel.text)" />
      </SlpTypography>
      <SlpButton
        variant="primary"
        :href="tabContent.panel.button.url"
        :data-ga-name="tabContent.panel.button.dataGaName"
        :data-ga-location="
          tabContent.panel.button.dataGaLocation || `side navigation`
        "
      >
        {{ tabContent.panel.button.text }}
      </SlpButton>
    </div>
  </article>
</template>

<style lang="scss" scoped>
.cta-tab__container {
  background: $color-surface-800;
  border-radius: 8px;
  padding: 16px;
  margin-bottom: 32px;

  &--heading {
    font-weight: $font-weight-bold;
    text-align: center;
    margin-bottom: 16px;
  }
}

.cta-tab__tablist {
  width: 100%;
  display: flex;
  .tab {
    cursor: pointer;
    font-size: $text-body-3;
    line-height: $line-height-body-3;
    padding: 16px;
    border: none;
    border-top: 3px solid transparent;
    flex-grow: 1;

    &:hover:not(.selected) {
      border-top: 3px solid $color-accent-400;
      font-weight: $font-weight-bold;
    }

    &.selected {
      background: $color-surface-50;
      font-weight: $font-weight-bold;
      border-top: 3px solid $color-accent-500;
    }
  }
}

.cta-tab__tabpanel {
  background: $color-surface-50;
  padding: 16px;

  .slp-btn {
    width: 100%;
    justify-content: center;
  }

  &:deep {
    strong {
      font-weight: $font-weight-bold;
    }
  }
}
</style>
